' Driver program for 'ADC supports 256 inputs,
' Published in Electronics Australia,  November 1996.
' Circuit and design ideas column.





'At address H378, the first for bits control U1 and the last four bits control
'U2.
'If 00000000 is sent, Input 1 at XO-YO will be monitored.If 00000001 is sent,
'Input 2 at XI-YO will be monitored.
'U3 then sends the data back in serial and monitor by address H379.
'Adress H37A is used to control the clock pulse and clear the ADC.
'......................................................................
'
'Program for 256ADC in MS-DOS Qbasic:written by Toh Yue Khing on 05-22-1996
'Output of the program in volts
'Default is LPT 1 ,if you wanl to use LPT 2 change &h378 to &h278,
'&h37A to &h27A and &h379 to &h279

CLS              'clear the screen
DO
x = O
y = O
FOR x = O TO 15
LOCATE 1, 4 * x + 5


PRINT x
FOR y = 0 TO 15
PRINT y
LOCATE 21, 21
port = y + x * 16
OUT &H378, port  'sent address to analog multiplexer
'code for getting data for ADC
  OUT &H37A, 1     'clear the chip data
  OUT &H37A, 3     'sent a clock pulse
  OUT &H37A, 2
  a = INP(&H379) AND 8          'get the first bit
  a = a * 16
  OUT &H37A, 3
  OUT &H37A, 2
  b = INP(&H379) AND 8          'get the second bit
  b = b * 8
  a = a + b
  OUT &H37A, 3
  OUT &H37A, 2
  b = INP(&H379) AND 8          'get the third bit
  b = b * 4
  a = a + b
  OUT &H37A, 3
  OUT &H37A, 2
  b = INP(&H379) AND 8          'get the four bit
  b = b * 2
  a = a + b
  OUT &H37A, 3
  OUT &H37A, 2
  b = INP(&H379) AND 8          'get the fifth bit
  a = a + b
  OUT &H37A, 3
  OUT &H37A, 2
  b = INP(&H379) AND 8          'get the six bit
  b = b / 2
  a = a + b
  OUT &H37A, 3
  OUT &H37A, 2
  b = INP(&H379) AND 8          'get the seven bit
  b = b / 4
  a = a + b
  OUT &H37A, 3
  OUT &H37A, 2
  b = INP(&H379) AND 8         'get the eight bit
  b = b / 8
  a = a + b                     'compute the result
  OUT &H37A, 3
  LOCATE y + 2, 4 * x + 5
PRINT CHR$(255); CHR$(255); CHR$(255); CHR$(255) 'clear the previous number
LOCATE y + 2, 4 * x + 5
PRINT INT(a / 255 * 5 * 10) / 10   'round off to 1 decimal place
NEXT y
NEXT x
LOOP UNTIL INKEY$ = CHR$(27)  'loop until "ESC" key is press


